Index: src/train_cmd.cpp
===================================================================
--- src/train_cmd.cpp	(revision 13683)
+++ src/train_cmd.cpp	(working copy)
@@ -39,6 +39,7 @@
 #include "tunnelbridge_map.h"
 #include "strings_func.h"
 #include "functions.h"
+#include "sharedinfrastructure.h"
 #include "window_func.h"
 #include "date_func.h"
 #include "vehicle_func.h"
@@ -51,6 +52,7 @@
 #include "order_func.h"
 #include "newgrf_station.h"
 #include "effectvehicle_func.h"
+#include <stack>
 
 #include "table/strings.h"
 #include "table/train_cmd.h"
@@ -697,15 +699,22 @@
 	 * to the player. Doesn't matter if only the cost is queried */
 	if (!(flags & DC_QUERY_COST)) {
 		if (!IsRailDepotTile(tile)) return CMD_ERROR;
-		if (!IsTileOwner(tile, _current_player)) return CMD_ERROR;
+		if (!IsTileOwner(tile, _current_player) && !SharedRailwayDepots(tile, _current_player)) return CMD_ERROR;
 	}
 
 	const RailVehicleInfo *rvi = RailVehInfo(p1);
 
-	if (rvi->railveh_type == RAILVEH_WAGON) return CmdBuildRailWagon(p1, tile, flags);
+	CommandCost value;
+	if (rvi->railveh_type == RAILVEH_WAGON) {
+		value = CmdBuildRailWagon(p1, tile, flags);
+		SharedDepotProvision(value, GetTileOwner(tile), flags);
 
-	CommandCost value = EstimateTrainCost(p1, rvi);
+		return value;
+	}
 
+	value = EstimateTrainCost(p1, rvi);
+
+
 	uint num_vehicles =
 		(rvi->railveh_type == RAILVEH_MULTIHEAD ? 2 : 1) +
 		CountArticulatedParts(p1, false);
@@ -812,7 +821,7 @@
 			GetPlayer(_current_player)->num_engines[p1]++;
 		}
 	}
-
+	SharedDepotProvision(value, GetTileOwner(tile), flags);
 	return value;
 }
 
@@ -1290,7 +1299,7 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	/* Check if this train can be started/stopped. The callback will fail or
 	 * return 0xFF if it can. */
@@ -1858,7 +1867,8 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	/* In order to sort out jams on your tracks you have to be able to turn trains */
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	if (p2 != 0) {
 		/* turn a single unit around */
@@ -1907,7 +1917,10 @@
 
 	Vehicle *v = GetVehicle(p1);
 
-	if (v->type != VEH_TRAIN || !CheckOwnership(v->owner)) return CMD_ERROR;
+	/** A track owner must stay in control of his tracks so others cannot 
+	 *  produce forcefully crashes there
+	 */
+	if (v->type != VEH_TRAIN || !IsTileOwner(tile, _current_player)) return CMD_ERROR;
 
 	if (flags & DC_EXEC) v->u.rail.force_proceed = 0x50;
 
@@ -2731,7 +2744,8 @@
 static inline bool CheckCompatibleRail(const Vehicle *v, TileIndex tile)
 {
 	return
-		IsTileOwner(tile, v->owner) && (
+		(IsTileOwner(tile, v->owner) || 
+			(SharedTracks(tile, v->owner))) && (
 			!IsFrontEngine(v) ||
 			HasBit(v->u.rail.compatible_railtypes, GetRailType(tile))
 		);
@@ -3623,7 +3637,6 @@
 					v->index,
 					0);
 			}
-
 			v->profit_last_year = v->profit_this_year;
 			v->profit_this_year = 0;
 			InvalidateWindow(WC_VEHICLE_DETAILS, v->index);
Index: src/road_cmd.cpp
===================================================================
--- src/road_cmd.cpp	(revision 13683)
+++ src/road_cmd.cpp	(working copy)
@@ -329,7 +329,7 @@
 
 			/* If we change the foundation we have to pay for it. */
 			return CommandCost(EXPENSES_CONSTRUCTION, CountBits(pieces) * _price.remove_road +
-					((GetRoadFoundation(tileh, present) != f) ? _price.terraform : (Money)0));
+					((GetRoadFoundation(tileh, present) != f) ? (_price.build_rail <<3) : (Money)0));
 		}
 
 		case ROAD_TILE_CROSSING: {
@@ -410,7 +410,7 @@
 		existing |= other;
 
 		if ((existing == ROAD_NONE || existing == *pieces) && IsStraightRoad(*pieces)) {
-			return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+			return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 		}
 		return CMD_ERROR;
 	}
@@ -422,7 +422,7 @@
 	if (_settings_game.construction.build_on_slopes && (_invalid_tileh_slopes_road[0][tileh] & (other | type_bits)) == ROAD_NONE) {
 
 		/* If we add leveling we've got to pay for it */
-		if ((other | existing) == ROAD_NONE) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+		if ((other | existing) == ROAD_NONE) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 
 		return CommandCost();
 	}
@@ -442,12 +442,12 @@
 			if (_settings_game.construction.build_on_slopes) {
 
 				/* If we add foundation we've got to pay for it */
-				if ((other | existing) == ROAD_NONE) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+				if ((other | existing) == ROAD_NONE) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 
 				return CommandCost();
 			}
 		} else {
-			if (CountBits(existing) == 1) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+			if (CountBits(existing) == 1) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 			return CommandCost();
 		}
 	}
@@ -1575,11 +1575,11 @@
 	if (_settings_game.construction.build_on_slopes && AutoslopeEnabled()) {
 		switch (GetRoadTileType(tile)) {
 			case ROAD_TILE_CROSSING:
-				if (!IsSteepSlope(tileh_new) && (GetTileMaxZ(tile) == z_new + GetSlopeMaxZ(tileh_new)) && HasBit(VALID_LEVEL_CROSSING_SLOPES, tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+				if (!IsSteepSlope(tileh_new) && (GetTileMaxZ(tile) == z_new + GetSlopeMaxZ(tileh_new)) && HasBit(VALID_LEVEL_CROSSING_SLOPES, tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 				break;
 
 			case ROAD_TILE_DEPOT:
-				if (AutoslopeCheckForEntranceEdge(tile, z_new, tileh_new, GetRoadDepotDirection(tile))) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+				if (AutoslopeCheckForEntranceEdge(tile, z_new, tileh_new, GetRoadDepotDirection(tile))) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 				break;
 
 			case ROAD_TILE_NORMAL: {
@@ -1597,7 +1597,7 @@
 						z_new += ApplyFoundationToSlope(GetRoadFoundation(tileh_new, bits), &tileh_new);
 
 						/* The surface slope must not be changed */
-						if ((z_old == z_new) && (tileh_old == tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+						if ((z_old == z_new) && (tileh_old == tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 					}
 				}
 				break;
Index: src/command.cpp
===================================================================
--- src/command.cpp	(revision 13683)
+++ src/command.cpp	(working copy)
@@ -18,6 +18,9 @@
 #include "town.h"
 #include "date_func.h"
 #include "debug.h"
+#include "window_func.h"
+#include "viewport_type.h"
+#include "viewport_func.h"
 #include "player_func.h"
 #include "player_base.h"
 #include "signal_func.h"
@@ -198,6 +201,11 @@
 DEF_COMMAND(CmdChangeTimetable);
 DEF_COMMAND(CmdSetVehicleOnTime);
 DEF_COMMAND(CmdAutofillTimetable);
+
+DEF_COMMAND(CmdSetSharedBoolValues);
+DEF_COMMAND(CmdSetSharedIntValues);
+
+DEF_COMMAND(CmdOpenCloseAirport);
 #undef DEF_COMMAND
 
 /**
@@ -346,6 +354,11 @@
 	{CmdChangeTimetable,                     0}, /* CMD_CHANGE_TIMETABLE */
 	{CmdSetVehicleOnTime,                    0}, /* CMD_SET_VEHICLE_ON_TIME */
 	{CmdAutofillTimetable,                   0}, /* CMD_AUTOFILL_TIMETABLE */
+
+	{CmdSetSharedBoolValues,                 0}, /* CMD_SET_SHARED_BOOL_VALUES */
+	{CmdSetSharedIntValues,                  0}, /* CMD_SET_SHARED_INT_VALUES */
+ 
+ 	{CmdOpenCloseAirport,                    0}, /* CMD_OPEN_CLOSE_AIRPORT */
 };
 
 /*!
@@ -449,7 +462,17 @@
 		SubtractMoneyFromPlayer(res);
 		/* XXX - Old AI hack which doesn't use DoCommandDP; update last build coord of player */
 		if (tile != 0 && IsValidPlayer(_current_player)) {
-			GetPlayer(_current_player)->last_build_coordinate = tile;
+			Player *p = GetPlayer(_current_player);
+			if (p->last_build_coordinate != tile) {
+				p->last_build_coordinate = tile;
+				if (p->window != -1) {
+					Window *w = FindWindowById(WC_EXTRA_VIEW_PORT, p->window);
+					if (w != NULL)
+						ScrollWindowTo(TileX(tile) * TILE_SIZE + TILE_SIZE / 2, TileY(tile) * TILE_SIZE + TILE_SIZE / 2, w, true);
+					else
+						p->window = -1;  // TODO: player initiated to '0'
+				}
+			}
 		}
 	}
 
@@ -609,7 +632,17 @@
 
 	/* update last build coordinate of player. */
 	if (tile != 0 && IsValidPlayer(_current_player)) {
-		GetPlayer(_current_player)->last_build_coordinate = tile;
+		Player *p = GetPlayer(_current_player);
+		if (p->last_build_coordinate != tile) {
+			p->last_build_coordinate = tile;
+			if (p->window != -1) {
+				Window *w = FindWindowById(WC_EXTRA_VIEW_PORT, p->window);
+				if (w != NULL)
+					ScrollWindowTo(TileX(tile) * TILE_SIZE + TILE_SIZE / 2, TileY(tile) * TILE_SIZE + TILE_SIZE / 2, w, true);
+				else
+					p->window = -1;  // TODO: player initiated to '0'
+			}
+		}
 	}
 
 	/* Actually try and execute the command. If no cost-type is given
Index: src/settings_func.h
===================================================================
--- src/settings_func.h	(revision 13683)
+++ src/settings_func.h	(working copy)
@@ -14,4 +14,10 @@
 void SaveToConfig();
 void CheckConfig();
 
+/* Functions to load and save NewGRF settings to a separate
+ * configuration file, used for presets. */
+void GetGRFPresetList();
+struct GRFConfig *LoadGRFPresetFromConfig(const char *config_name);
+void SaveGRFPresetToConfig(const char *config_name, struct GRFConfig *config);
+
 #endif /* SETTINGS_FUNC_H */
Index: src/tree_cmd.cpp
===================================================================
--- src/tree_cmd.cpp	(revision 13683)
+++ src/tree_cmd.cpp	(working copy)
@@ -650,6 +650,8 @@
 	}
 	SetTreeCounter(tile, 0);
 
+ 	if (_settings_game.construction.disable_tree_growth == false)
+ 	{
 	switch (GetTreeGrowth(tile)) {
 		case 3: /* regular sized tree */
 			if (_settings_game.game_creation.landscape == LT_TROPIC &&
@@ -714,12 +716,14 @@
 			AddTreeGrowth(tile, 1);
 			break;
 	}
-
+	}
 	MarkTileDirtyByTile(tile);
 }
 
 void OnTick_Trees()
 {
+ 	if (_settings_game.construction.disable_tree_growth == false)
+ 	{
 	uint32 r;
 	TileIndex tile;
 	TreeType tree;
@@ -741,6 +745,7 @@
 	if (CanPlantTreesOnTile(tile, false) && (tree = GetRandomTreeType(tile, GB(r, 24, 8))) != TREE_INVALID) {
 		PlantTreesOnTile(tile, tree, 0, 0);
 	}
+	}
 }
 
 static void ClickTile_Trees(TileIndex tile)
Index: src/player_base.h
===================================================================
--- src/player_base.h	(revision 13683)
+++ src/player_base.h	(working copy)
@@ -62,6 +62,8 @@
 	bool is_active;
 	bool is_ai;
 
+	int window;
+
 	Money yearly_expenses[3][EXPENSES_END];
 	PlayerEconomyEntry cur_economy;
 	PlayerEconomyEntry old_economy[24];
@@ -71,6 +73,26 @@
 	int16 engine_renew_months;
 	uint32 engine_renew_money;
 	uint16 *num_engines; ///< caches the number of engines of each type the player owns (no need to save this)
+
+	/** Shared infrastructure
+	 * first element is actual value
+	 * second is value to be set at end of shared_change_months counter
+	 * (see patch value of shared_delay)
+	 */
+	bool shared_railway_tracks[2];
+	bool shared_railway_stations[2];
+	bool shared_railway_depots[2];
+	uint16 shared_tontile_cost[2];
+	uint8 shared_road_stops_fee[2];
+	uint8 shared_harbours_fee[2];
+	bool shared_airports[2];
+	uint16 shared_landing_fee[2];
+	bool shared_road_depots[2];
+	bool shared_road_stops[2];
+	bool shared_water_depots[2];
+	bool shared_harbours[2];
+	uint8 shared_provision[2];
+	uint8 shared_change_months;
 };
 
 struct PlayerMoneyBackup {
Index: src/rail_gui.cpp
===================================================================
--- src/rail_gui.cpp	(revision 13683)
+++ src/rail_gui.cpp	(working copy)
@@ -184,10 +184,21 @@
 		VpStartPlaceSizing(tile, VPM_X_AND_Y_LIMITED, DDSP_BUILD_STATION);
 		VpSetPlaceSizingLimit(_settings_game.station.station_spread);
 	} else {
-		DoCommandP(tile,
-				_railstation.orientation | (_railstation.numtracks << 8) | (_railstation.platlength << 16) | (_ctrl_pressed << 24),
-				_cur_railtype | (_railstation.station_class << 8) | (_railstation.station_type << 16), CcStation,
-				CMD_BUILD_RAILROAD_STATION | CMD_NO_WATER | CMD_MSG(STR_100F_CAN_T_BUILD_RAILROAD_STATION));
+		int w = _railstation.numtracks;
+		int h = _railstation.platlength;
+		if (!_railstation.orientation) Swap(w, h);
+
+		uint32 p1 = _cur_railtype | (_railstation.orientation << 4) | (_railstation.numtracks << 8) | (_railstation.platlength << 16) | (_ctrl_pressed << 24);
+		uint32 p2 = _railstation.station_class | (_railstation.station_type << 8) | (INVALID_STATION << 16);
+
+		if (StationJoinerNeeded(tile, w, h)) {
+			CommandContainer cmd = {tile, p1, p2, CcStation,
+					CMD_BUILD_RAILROAD_STATION | CMD_NO_WATER | CMD_MSG(STR_100F_CAN_T_BUILD_RAILROAD_STATION)};
+			ShowSelectStation(cmd, STATION_RAIL, true, true);
+		} else {
+			DoCommandP(tile, p1, p2, CcStation,
+					CMD_BUILD_RAILROAD_STATION | CMD_NO_WATER | CMD_MSG(STR_100F_CAN_T_BUILD_RAILROAD_STATION));
+		}
 	}
 }
 
@@ -752,6 +763,7 @@
 		delete FindWindowById(WC_BUILD_SIGNAL, 0);
 		delete FindWindowById(WC_BUILD_STATION, 0);
 		delete FindWindowById(WC_BUILD_DEPOT, 0);
+		delete FindWindowById(WC_SELECT_STATION, 0);
 	}
 
 	virtual void OnPlacePresize(Point pt, TileIndex tile)
@@ -872,12 +884,21 @@
 	if (sy > ey) Swap(sy, ey);
 	w = ex - sx + 1;
 	h = ey - sy + 1;
-	if (!_railstation.orientation) Swap(w, h);
 
-	DoCommandP(TileXY(sx, sy),
-			_railstation.orientation | (w << 8) | (h << 16) | (_ctrl_pressed << 24),
-			_cur_railtype | (_railstation.station_class << 8) | (_railstation.station_type << 16), CcStation,
+	uint32 p1 = _cur_railtype | (_railstation.orientation << 4) | (_ctrl_pressed << 24);
+	uint32 p2 = _railstation.station_class | (_railstation.station_type << 8) | (INVALID_STATION << 16);
+
+	if (StationJoinerNeeded(TileXY(sx, sy), w, h)) {
+		if (!_railstation.orientation) Swap(w, h);
+		CommandContainer cmd = {TileXY(sx, sy), p1 | (w << 8) | (h << 16), p2,
+			CcStation,
+			CMD_BUILD_RAILROAD_STATION | CMD_NO_WATER | CMD_MSG(STR_100F_CAN_T_BUILD_RAILROAD_STATION)};
+		ShowSelectStation(cmd, STATION_RAIL, true, true);
+	} else {
+		if (!_railstation.orientation) Swap(w, h);
+		DoCommandP(TileXY(sx, sy), p1 | (w << 8) | (h << 16), p2, CcStation,
 			CMD_BUILD_RAILROAD_STATION | CMD_NO_WATER | CMD_MSG(STR_100F_CAN_T_BUILD_RAILROAD_STATION));
+	}
 }
 
 struct BuildRailStationWindow : public PickerWindowBase {
Index: src/tunnelbridge_cmd.cpp
===================================================================
--- src/tunnelbridge_cmd.cpp	(revision 13683)
+++ src/tunnelbridge_cmd.cpp	(working copy)
@@ -93,6 +93,28 @@
 }
 
 /**
+ * Returns the fastest currently available BridgeType for given length.
+ */
+BridgeType GetFastestAvailableBridgeType(uint bridge_len)
+{
+	BridgeType fastest_type = MAX_BRIDGES;
+	uint16 fastest_speed = 0;
+
+	for (BridgeType brd_type = 0; brd_type != MAX_BRIDGES; brd_type++) {
+		if (CheckBridge_Stuff(brd_type, bridge_len)) {
+			/* bridge is available, compare speeds */
+			const BridgeSpec *b = GetBridgeSpec(brd_type);
+			if (b->speed >= fastest_speed) {
+				fastest_type = brd_type;
+				fastest_speed = b->speed;
+			}
+		}
+	}
+
+	return fastest_type;
+}
+
+/**
  * Determines if the track on a bridge ramp is flat or goes up/down.
  *
  * @param tileh Slope of the tile under the bridge head
@@ -136,7 +158,7 @@
 
 	if (f == FOUNDATION_NONE) return CommandCost();
 
-	return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+	return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 }
 
 /**
@@ -157,7 +179,7 @@
 
 	if (f == FOUNDATION_NONE) return CommandCost();
 
-	return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+	return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 }
 
 bool CheckBridge_Stuff(BridgeType bridge_type, uint bridge_len, uint32 flags)
@@ -1446,7 +1468,7 @@
 		}
 
 		/* Surface slope is valid and remains unchanged? */
-		if (!CmdFailed(res) && (z_old == z_new) && (tileh_old == tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, _price.terraform);
+		if (!CmdFailed(res) && (z_old == z_new) && (tileh_old == tileh_new)) return CommandCost(EXPENSES_CONSTRUCTION, (_price.build_rail <<3));
 	}
 
 	return DoCommand(tile, 0, 0, flags, CMD_LANDSCAPE_CLEAR);
Index: src/settings_type.h
===================================================================
--- src/settings_type.h	(revision 13683)
+++ src/settings_type.h	(working copy)
@@ -71,6 +71,7 @@
 	Year   ending_year;                      ///< end of the game (just show highscore)
 	Year   colored_news_year;                ///< when does newspaper become colored?
 	bool   timetable_in_ticks;               ///< whether to show the timetable in ticks rather than days
+	bool   quick_goto;                       ///< Allow quick access to 'goto button' in vehicle orders window
 	bool   bridge_pillars;                   ///< show bridge pillars for high bridges
 	bool   auto_euro;                        ///< automatically switch to euro in 2002
 	byte   drag_signals_density;             ///< many signals density
@@ -148,6 +149,9 @@
 	bool   extra_dynamite;                   ///< extra dynamite
 	bool   road_stop_on_town_road;           ///< allow building of drive-through road stops on town owned roads
 	uint8  raw_industry_construction;        ///< type of (raw) industry construction (none, "normal", prospecting)
+	bool   disable_tree_growth;				 ///< If trees are allowed to grow
+	bool   one_tile_terraform;               ///< allow only terraform of size "1 tile"
+	uint16 allow_terraform;                  ///< bitmask for companies allowed to terraform (only effective for network server)
 };
 
 /** Settings related to the AI. */
@@ -304,6 +308,25 @@
 	byte   station_spread;                   ///< amount a station may spread
 };
 
+ /** Shared Infrastructure **/
+struct SharingSettings {
+  	bool shared_railway_stations;          ///< allow railway stations sharing
+  	bool shared_railway_tracks;            ///< allow railway tracks sharing
+  	bool shared_railway_depots;            ///< allow railway depots sharing
+  	bool shared_road_depots;               ///< allow road depots sharing
+  	bool shared_road_stops;                ///< allow road stops sharing
+  	bool shared_water_depots;              ///< allow water depots sharing
+  	bool shared_harbours;                  ///< allow harbours sharing
+  	bool shared_airports;                  ///< allow airports sharing
+  	int8 shared_provision;                 ///< default value for depots provision (buy cost %)
+  	uint16 shared_tontile_cost;            ///< default value for tracks sharing payment (per 1000 tons per tiles)
+  	uint16 shared_landing_fee;             ///< default value for airports landing fee (per tons of cargo capacity)
+  	int8 shared_road_stops_fee;            ///< default value for entering road stops (per tons of cargo capacity)
+  	int8 shared_harbours_fee;              ///< default value for entering harbours (per tons of cargo capacity)
+  	bool shared_player_level;              ///< allow players to set individual sharing settings
+  	uint8 shared_delay;                    ///< delay before activating individual sharing settings 
+};  
+
 /** All settings together for the game. */
 struct GameSettings {
 	DifficultySettings   difficulty;         ///< settings related to the difficulty
@@ -315,6 +338,7 @@
 	VehicleSettings      vehicle;            ///< options for vehicles
 	EconomySettings      economy;            ///< settings to change the economy
 	StationSettings      station;            ///< settings related to station management
+ 	SharingSettings		 sharing;            ///< settings related to infrastructure sharing
 	LocaleSettings       locale;             ///< settings related to used currency/unit system in the current game
 };
 
Index: src/depot_gui.cpp
===================================================================
--- src/depot_gui.cpp	(revision 13683)
+++ src/depot_gui.cpp	(working copy)
@@ -27,6 +27,7 @@
 #include "tilehighlight_func.h"
 #include "window_gui.h"
 #include "vehiclelist.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -314,7 +315,7 @@
 		uint16 boxes_in_each_row = this->widget[DEPOT_WIDGET_MATRIX].data & 0xFF;
 
 		/* setup disabled buttons */
-		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_player),
+		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_player) && !SharedDepotVehicleType(tile,_local_player, this->type),
 			DEPOT_WIDGET_STOP_ALL,
 			DEPOT_WIDGET_START_ALL,
 			DEPOT_WIDGET_SELL,
Index: src/command_type.h
===================================================================
--- src/command_type.h	(revision 13683)
+++ src/command_type.h	(working copy)
@@ -278,6 +278,10 @@
 	CMD_CHANGE_TIMETABLE,             ///< change the timetable for a vehicle
 	CMD_SET_VEHICLE_ON_TIME,          ///< set the vehicle on time feature (timetable)
 	CMD_AUTOFILL_TIMETABLE,           ///< autofill the timetable
+	CMD_SET_SHARED_BOOL_VALUES,       ///< set shared infrastructure player bool value
+	CMD_SET_SHARED_INT_VALUES,        ///< set shared infrastructure player int value
+ 
+ 	CMD_OPEN_CLOSE_AIRPORT,           ///< open/close an airport
 };
 
 /**
@@ -375,4 +379,15 @@
  */
 typedef void CommandCallback(bool success, TileIndex tile, uint32 p1, uint32 p2);
 
+/**
+ * Structure for buffering the build command when selecting a station to join.
+ */
+struct CommandContainer {
+	TileIndex tile;
+	uint32 p1;
+	uint32 p2;
+	CommandCallback *callback;
+	uint32 cmd;
+};
+
 #endif /* COMMAND_TYPE_H */
